## falcosecurity-libs 0.15.1

=== CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
#
# Copyright (C) 2023 The Falco Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

# Prior to doing anything, we make sure that we aren't trying to
# run cmake in-tree.
if(EXISTS ${CMAKE_CURRENT_BINARY_DIR}/CMakeLists.txt)
	message(FATAL_ERROR
		"Looks like you are trying to run CMake from the base source directory.\n"
		"** RUNNING CMAKE FROM THE BASE DIRECTORY WILL NOT WORK **\n"
		"To Fix:\n"
		" 1. Remove the CMakeCache.txt file in this directory. ex: rm CMakeCache.txt\n"
		" 2. Create a build directory from here. ex: mkdir build\n"
		" 3. cd into that directory. ex: cd build\n"
		" 4. Run cmake from the build directory. ex: cmake ..\n"
		" 5. Run make from the build directory. ex: make\n"
		"Full paste-able example:\n"
		"( rm -f CMakeCache.txt; mkdir build; cd build; cmake ..; make )")
endif()

cmake_minimum_required(VERSION 3.12)

# Enable MACOSX_RPATH (and keep CMake from complaining).
if(POLICY CMP0042)
	cmake_policy(SET CMP0042 NEW)
endif()

# Enable CMAKE_MSVC_RUNTIME_LIBRARY on Windows + CMake >= 3.15 and link
# with the static (MultiThreaded) CRT unless instructed otherwise.
if(NOT (CMAKE_MSVC_RUNTIME_LIBRARY OR BUILD_SHARED_LIBS))
	set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
endif()
if(POLICY CMP0091)
	cmake_policy(SET CMP0091 NEW)
endif()

if(POLICY CMP0135)
	cmake_policy(SET CMP0135 NEW)
endif()

project(falcosecurity-libs)

option(USE_BUNDLED_DEPS "Enable bundled dependencies instead of using the system ones" ON)
option(MINIMAL_BUILD "Produce a minimal build with only the essential features (no container metadata)" OFF)
option(MUSL_OPTIMIZED_BUILD "Enable if you want a musl optimized build" OFF)
option(USE_BUNDLED_DRIVER "Use the driver/ subdirectory in the build process (only available in Linux)" ON)
option(ENABLE_DRIVERS_TESTS "Enable driver tests (bpf, kernel module, modern bpf)" OFF)
option(ENABLE_LIBSCAP_TESTS "Enable libscap unit tests" OFF)
option(ENABLE_LIBSINSP_E2E_TESTS "Enable libsinsp e2e tests" OFF)
option(BUILD_SHARED_LIBS "Build libscap and libsinsp as shared libraries" OFF)
option(ENABLE_VM_TESTS "Enable driver sanity tests" OFF)
option(USE_ASAN "Build with AddressSanitizer" OFF)
option(USE_UBSAN "Build with UndefinedBehaviorSanitizer" OFF)
option(UBSAN_HALT_ON_ERROR "Halt on error when building with UBSan" ON)

if(${CMAKE_VERSION} VERSION_LESS "3.1.0" AND BUILD_SHARED_LIBS)
	# scap_engine_savefile uses target_sources
	message(FATAL_ERROR "Shared libraries requires CMake 3.1 or later.")
endif()

include(GNUInstallDirs)

# Add path for custom CMake modules.
list(APPEND CMAKE_MODULE_PATH
	"${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")

include(versions)

# Libs version
if(NOT DEFINED FALCOSECURITY_LIBS_VERSION)
	get_libs_version(FALCOSECURITY_LIBS_VERSION)
endif()

message(STATUS "Libs version: ${FALCOSECURITY_LIBS_VERSION}")

if(CMAKE_SYSTEM_NAME MATCHES "Linux" AND USE_BUNDLED_DRIVER)
	# Driver version
	if(NOT DEFINED DRIVER_VERSION)
		get_drivers_version(DRIVER_VERSION)
	endif()

	message(STATUS "Driver version: ${DRIVER_VERSION}")

	add_subdirectory(driver ${PROJECT_BINARY_DIR}/driver)
endif()

if(NOT DEFINED CMAKE_BUILD_TYPE OR CMAKE_BUILD_TYPE STREQUAL "")
	set(CMAKE_BUILD_TYPE "Release")
endif()

set(LIBS_PACKAGE_NAME "falcosecurity")

include(CompilerFlags)

option(WITH_CHISEL "Include chisel implementation" OFF)

option(CREATE_TEST_TARGETS "Enable make-targets for unit testing" ON)

if(CREATE_TEST_TARGETS)
	include(gtest)
endif()

if (BUILD_SHARED_LIBS)
	get_shared_libs_versions(FALCOSECURITY_SHARED_LIBS_VERSION FALCOSECURITY_SHARED_LIBS_SOVERSION)
	message(STATUS "Shared library version: ${FALCOSECURITY_SHARED_LIBS_VERSION}")
	message(STATUS "Shared library soversion: ${FALCOSECURITY_SHARED_LIBS_SOVERSION}")
endif()

include(libscap)
include(libsinsp)

if(CREATE_TEST_TARGETS)
	# Add command to run all unit tests at once via the make system.
	# This is preferred vs using ctest's add_test because it will build
	# the code and output to stdout.
	add_custom_target(run-unit-tests
		COMMAND ${CMAKE_MAKE_PROGRAM} run-unit-test-libsinsp
	)

	add_subdirectory(test/e2e)

	if(ENABLE_DRIVERS_TESTS)
		add_subdirectory(test/drivers)
	endif()

	if(ENABLE_LIBSCAP_TESTS)
		add_subdirectory(test/libscap)
	endif()

	if(ENABLE_LIBSINSP_E2E_TESTS)
		message(WARNING "LIBSINSP_E2E_TESTS are experimental!")
		add_subdirectory(test/libsinsp_e2e)
		add_subdirectory(test/libsinsp_e2e/resources)
	endif()

	if(ENABLE_VM_TESTS)
		add_subdirectory(test/vm)
	endif()

endif()

=== driver/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0-only OR MIT
#
# Copyright (C) 2023 The Falco Authors.
#
# This file is dual licensed under either the MIT or GPL 2. See
# MIT.txt or GPL.txt for full copies of the license.
#

cmake_minimum_required(VERSION 3.12)
project(driver)

set(TARGET_ARCH ${CMAKE_HOST_SYSTEM_PROCESSOR})
if((NOT TARGET_ARCH STREQUAL "x86_64") AND
   (NOT TARGET_ARCH STREQUAL "aarch64") AND
   (NOT TARGET_ARCH STREQUAL "s390x") AND
   (NOT TARGET_ARCH STREQUAL "riscv64") AND
   (NOT TARGET_ARCH STREQUAL "ppc64le"))
	message(WARNING "Target architecture not officially supported by our drivers!")
else()
	# Load current kernel version
	execute_process(COMMAND uname -r OUTPUT_VARIABLE UNAME_RESULT OUTPUT_STRIP_TRAILING_WHITESPACE)
	string(REGEX MATCH "[0-9]+.[0-9]+" LINUX_KERNEL_VERSION ${UNAME_RESULT})
	message(STATUS  "Kernel version: ${UNAME_RESULT}")

	# Check minimum kernel version
	set(kmod_min_kver_map_x86_64 2.6)
	set(kmod_min_kver_map_aarch64 3.16)
	set(kmod_min_kver_map_s390x 2.6)
	set(kmod_min_kver_map_riscv64 5.0)
	set(kmod_min_kver_map_ppc64le 2.6)
	if (LINUX_KERNEL_VERSION VERSION_LESS ${kmod_min_kver_map_${TARGET_ARCH}})
		message(WARNING "[KMOD] To run this driver you need a Linux kernel version >= ${kmod_min_kver_map_${TARGET_ARCH}} but actual kernel version is: ${UNAME_RESULT}")
	endif()
endif()

option(BUILD_DRIVER "Build the driver on Linux" ON)
option(ENABLE_DKMS "Enable DKMS on Linux" ON)

if(NOT DEFINED DRIVER_VERSION)
	message(FATAL_ERROR
		"No DRIVER_VERSION set.\nPlease either explicitly set it or build the root project 'falcosecurity/libs' from a git working directory."
	)
endif()

if(NOT DEFINED DRIVER_COMPONENT_NAME)
	set(DRIVER_COMPONENT_NAME "scap-driver")
endif()
if(NOT DEFINED DRIVER_KMOD_COMPONENT_NAME)
	set(DRIVER_KMOD_COMPONENT_NAME ${DRIVER_COMPONENT_NAME})
endif()

if(NOT DEFINED DRIVER_PACKAGE_NAME)
	set(DRIVER_PACKAGE_NAME "scap")
endif()

if(NOT DEFINED DRIVER_NAME)
	set(DRIVER_NAME "scap")
endif()

if(NOT DEFINED DRIVER_DEVICE_NAME)
	set(DRIVER_DEVICE_NAME "${DRIVER_NAME}")
endif()

# The driver build process is somewhat involved because we use the same
# sources for building the driver locally and for shipping as a DKMS module.
#
# We need a single directory with the following files inside:
# - all the driver *.c/*.h sources
# - Makefile generated from Makefile.in
# - driver_config.h generated from driver_config.h.in
#
# The Makefile _must_ be called just Makefile (and not e.g. Makefile.dkms)
# because of the module build process, which looks like this:
# 1. The user (or some script) runs make in our driver directory
# 2. Our Makefile runs the Makefile from kernel sources/headers
# 3. The kernel Makefile calls our original Makefile again, with options that
# trigger the actual build. This step cannot know that our Makefile has
# a different name.
#
# (DKMS needs a Makefile called Makefile as well).
#
# The files need to be in a single directory because we cannot know where
# the sources will be built (especially by DKMS) so we cannot put _any_ paths
# in the Makefile.
#
# The chosen directory must not be ${CMAKE_CURRENT_BINARY_DIR} because CMake
# puts its own generated Makefile in there, so we (arbitrarily) choose
# ${CMAKE_CURRENT_BINARY_DIR}/src. To maintain compatibility with older versions,
# after the build we copy the compiled module one directory up,
# to ${CMAKE_CURRENT_BINARY_DIR}.
include(compute_versions RESULT_VARIABLE RESULT)
if(RESULT STREQUAL NOTFOUND)
  message(FATAL_ERROR "problem with compute_versions.cmake in ${CMAKE_MODULE_PATH}")
endif()
compute_versions(API_VERSION SCHEMA_VERSION)

configure_file(dkms.conf.in src/dkms.conf)
configure_file(Makefile.in src/Makefile)
configure_file(driver_config.h.in src/driver_config.h)

#
# Copy all the "configure" modules
#
file(GLOB configure_modules "${CMAKE_CURRENT_SOURCE_DIR}/configure/*")
foreach(subdir ${configure_modules})
	if(IS_DIRECTORY "${subdir}")
		file(RELATIVE_PATH CONFIGURE_MODULE "${CMAKE_CURRENT_SOURCE_DIR}/configure" "${subdir}")
		configure_file(configure/${CONFIGURE_MODULE}/test.c src/configure/${CONFIGURE_MODULE}/test.c COPYONLY)
		configure_file(configure/Makefile src/configure/${CONFIGURE_MODULE}/Makefile COPYONLY)
		configure_file(configure/build.sh src/configure/${CONFIGURE_MODULE}/build.sh COPYONLY)
		configure_file(configure/Makefile.inc.in src/configure/${CONFIGURE_MODULE}/Makefile.inc)
		if(ENABLE_DKMS)
			install(FILES
				"${CMAKE_CURRENT_BINARY_DIR}/src/configure/${CONFIGURE_MODULE}/build.sh"
				"${CMAKE_CURRENT_BINARY_DIR}/src/configure/${CONFIGURE_MODULE}/test.c"
				"${CMAKE_CURRENT_BINARY_DIR}/src/configure/${CONFIGURE_MODULE}/Makefile"
				"${CMAKE_CURRENT_BINARY_DIR}/src/configure/${CONFIGURE_MODULE}/Makefile.inc"
				DESTINATION "src/${DRIVER_PACKAGE_NAME}-${DRIVER_VERSION}/configure/${CONFIGURE_MODULE}"
				COMPONENT ${DRIVER_KMOD_COMPONENT_NAME})
		endif()
	endif()
endforeach()


set(DRIVER_SOURCES
	dynamic_params_table.c
	event_table.c
	fillers_table.c
	flags_table.c
	kernel_hacks.h
	feature_gates.h
	main.c
	ppm.h
	ppm_api_version.h
	ppm_events.c
	ppm_events.h
	ppm_events_public.h
	ppm_fillers.c
	ppm_fillers.h
	ppm_flag_helpers.h
	ppm_ringbuffer.h
	syscall_table.c
	syscall_table64.c
	ppm_cputime.c
	ppm_version.h
	systype_compat.h
	ppm_tp.h
	ppm_tp.c
	ppm_consumer.h
	capture_macro.h
	socketcall_to_syscall.h
	syscall_ia32_64_map.c
)

foreach(FILENAME IN LISTS DRIVER_SOURCES)
	configure_file(${FILENAME} src/${FILENAME} COPYONLY)
endforeach()

# make can be self-referenced as $(MAKE) only from Makefiles but this
# triggers syntax errors with other generators such as Ninja
if(${CMAKE_GENERATOR} STREQUAL "Unix Makefiles")
	set(MAKE_COMMAND "$(MAKE)")
else()
	set(MAKE_COMMAND "make")
endif()

# This if/else is needed because you currently cannot manipulate dependencies
# of built-in targets like "all" in CMake:
# http://public.kitware.com/Bug/view.php?id=8438
if(BUILD_DRIVER)
	add_custom_target(driver ALL
		COMMAND ${MAKE_COMMAND}
		COMMAND "${CMAKE_COMMAND}" -E copy_if_different ${DRIVER_NAME}.ko "${CMAKE_CURRENT_BINARY_DIR}"
		WORKING_DIRECTORY src
		VERBATIM)
else()
	add_custom_target(driver
		COMMAND ${MAKE_COMMAND}
		COMMAND "${CMAKE_COMMAND}" -E copy_if_different ${DRIVER_NAME}.ko "${CMAKE_CURRENT_BINARY_DIR}"
		WORKING_DIRECTORY src
		VERBATIM)
endif()

add_custom_target(install_driver
	COMMAND ${MAKE_COMMAND} install
	DEPENDS driver
	WORKING_DIRECTORY src
	VERBATIM)

if(ENABLE_DKMS)
	install(FILES ${CMAKE_CURRENT_BINARY_DIR}/src/Makefile
		${CMAKE_CURRENT_BINARY_DIR}/src/dkms.conf
		${CMAKE_CURRENT_BINARY_DIR}/src/driver_config.h
		${DRIVER_SOURCES}
		DESTINATION "src/${DRIVER_PACKAGE_NAME}-${DRIVER_VERSION}"
		COMPONENT ${DRIVER_KMOD_COMPONENT_NAME})
endif()

add_subdirectory(bpf)

=== driver/bpf/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0-only OR MIT
#
# Copyright (C) 2023 The Falco Authors.
#
# This file is dual licensed under either the MIT or GPL 2. See
# MIT.txt or GPL.txt for full copies of the license.
#

configure_file(../driver_config.h.in ${CMAKE_CURRENT_SOURCE_DIR}/../driver_config.h)

option(BUILD_BPF "Build the BPF driver on Linux" OFF)

if(BUILD_BPF)
	# Check minimum kernel version
	set(bpf_min_kver_map_x86_64 4.14)
	set(bpf_min_kver_map_aarch64 4.17)
	set(bpf_min_kver_map_s390x 5.5)
	set(bpf_min_kver_map_ppc64le 4.18)
	if (LINUX_KERNEL_VERSION VERSION_LESS ${bpf_min_kver_map_${TARGET_ARCH}})
		message(WARNING "[BPF] To run this driver you need a Linux kernel version >= ${bpf_min_kver_map_${TARGET_ARCH}} but actual kernel version is: ${UNAME_RESULT}")
	endif()

	add_custom_target(bpf ALL
			COMMAND make
			COMMAND "${CMAKE_COMMAND}" -E copy_if_different probe.o "${CMAKE_CURRENT_BINARY_DIR}"
			WORKING_DIRECTORY src
			VERBATIM)
endif()

set(BPF_SOURCES
	bpf_helpers.h
	builtins.h
	filler_helpers.h
	fillers.h
	Makefile
	maps.h
	plumbing_helpers.h
	probe.c
	quirks.h
	ring_helpers.h
	missing_definitions.h
	types.h
)

if(NOT DEFINED DRIVER_BPF_COMPONENT_NAME)
	set(DRIVER_BPF_COMPONENT_NAME ${DRIVER_COMPONENT_NAME})
endif()

# Append driver headers too since they are used by bpf headers
file(GLOB DRIVER_HEADERS ${CMAKE_CURRENT_SOURCE_DIR}/../*.h)
list(APPEND BPF_SOURCES ${DRIVER_HEADERS})

set(INSTALL_SET "")
# Copy all needed sources under src folder in current binary dir
# and add them to the set of installed files
foreach(SOURCE IN LISTS BPF_SOURCES)
	get_filename_component(FILENAME ${SOURCE} NAME)
	configure_file(${SOURCE} src/${FILENAME} COPYONLY)
	list(APPEND INSTALL_SET ${CMAKE_CURRENT_BINARY_DIR}/src/${FILENAME})
endforeach()

install(FILES
	${INSTALL_SET}
	DESTINATION "src/${DRIVER_PACKAGE_NAME}-${DRIVER_VERSION}/bpf"
	COMPONENT ${DRIVER_BPF_COMPONENT_NAME}
)

#
# Copy all the "configure" modules
#
file(GLOB configure_modules "${CMAKE_CURRENT_SOURCE_DIR}/configure/*")
foreach(subdir ${configure_modules})
	if(IS_DIRECTORY "${subdir}")
		file(RELATIVE_PATH CONFIGURE_MODULE "${CMAKE_CURRENT_SOURCE_DIR}/configure" "${subdir}")
		configure_file(configure/${CONFIGURE_MODULE}/test.c src/configure/${CONFIGURE_MODULE}/test.c COPYONLY)
		configure_file(configure/Makefile src/configure/${CONFIGURE_MODULE}/Makefile COPYONLY)
		configure_file(configure/build.sh src/configure/${CONFIGURE_MODULE}/build.sh COPYONLY)
		configure_file(configure/Makefile.inc.in src/configure/${CONFIGURE_MODULE}/Makefile.inc)
		install(FILES
				"${CMAKE_CURRENT_BINARY_DIR}/src/configure/${CONFIGURE_MODULE}/build.sh"
				"${CMAKE_CURRENT_BINARY_DIR}/src/configure/${CONFIGURE_MODULE}/test.c"
				"${CMAKE_CURRENT_BINARY_DIR}/src/configure/${CONFIGURE_MODULE}/Makefile"
				"${CMAKE_CURRENT_BINARY_DIR}/src/configure/${CONFIGURE_MODULE}/Makefile.inc"
				DESTINATION "src/${DRIVER_PACKAGE_NAME}-${DRIVER_VERSION}/bpf/configure/${CONFIGURE_MODULE}"
				COMPONENT ${DRIVER_BPF_COMPONENT_NAME})
	endif()
endforeach()

=== driver/modern_bpf/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-2.0-only OR MIT
#
# Copyright (C) 2023 The Falco Authors.
#
# This file is dual licensed under either the MIT or GPL 2. See
# MIT.txt or GPL.txt for full copies of the license.
#

option(MODERN_BPF_DEBUG_MODE "Enable BPF debug prints" OFF)
option(MODERN_BPF_EXCLUDE_PROGS "Regex to exclude tail-called programs" "")

########################
# Debug mode
########################

if(MODERN_BPF_DEBUG_MODE)
  set(DEBUG "MODERN_BPF_DEBUG")
else()
  set(DEBUG "")
endif()
message(STATUS "${MODERN_BPF_LOG_PREFIX} MODERN_BPF_DEBUG_MODE: ${MODERN_BPF_DEBUG_MODE}")

########################
# Check kernel version.
########################

# We check it here because the skeleton could be provided with the `MODERN_BPF_SKEL_DIR` env variable
# so the compilation is still possible on older kernels.
execute_process(COMMAND uname -r OUTPUT_VARIABLE UNAME_RESULT OUTPUT_STRIP_TRAILING_WHITESPACE)
string(REGEX MATCH "[0-9]+.[0-9]+" LINUX_KERNEL_VERSION ${UNAME_RESULT})
set(modern_bpf_min_kver_map_x86_64 5.8)
set(modern_bpf_min_kver_map_aarch64 5.8)
set(modern_bpf_min_kver_map_s390x 5.8)
set(modern_bpf_min_kver_map_ppc64le 5.8)
if (LINUX_KERNEL_VERSION VERSION_LESS ${modern_bpf_min_kver_map_${CMAKE_HOST_SYSTEM_PROCESSOR}})
  message(WARNING "${MODERN_BPF_LOG_PREFIX} To run this driver you need a Linux kernel version >= ${modern_bpf_min_kver_map_${CMAKE_HOST_SYSTEM_PROCESSOR}} but actual kernel version is: ${UNAME_RESULT}")
endif()

########################
# Get driver version.
########################

# This is needed to obtain the modern bpf driver version
include(compute_versions RESULT_VARIABLE RESULT)
if(RESULT STREQUAL NOTFOUND)
  message(FATAL_ERROR "${MODERN_BPF_LOG_PREFIX} problem with compute_versions.cmake in ${CMAKE_MODULE_PATH}")
endif()
compute_versions(../API_VERSION ../SCHEMA_VERSION)
configure_file(../driver_config.h.in ${CMAKE_CURRENT_SOURCE_DIR}/../driver_config.h)

########################
# Check clang version.
########################

# If the user doesn't provide the path to `clang` try to find it locally
if(NOT MODERN_CLANG_EXE)
  find_program(MODERN_CLANG_EXE NAMES clang DOC "Path to clang executable")
  if(NOT MODERN_CLANG_EXE)
    message(FATAL_ERROR "${MODERN_BPF_LOG_PREFIX} unable to find clang")
  endif()
endif()

# If it is a relative path we convert it to an absolute one relative to the root source directory.
get_filename_component(MODERN_CLANG_EXE "${MODERN_CLANG_EXE}" REALPATH BASE_DIR "${CMAKE_SOURCE_DIR}")
message(STATUS "${MODERN_BPF_LOG_PREFIX} clang used by the modern bpf probe: '${MODERN_CLANG_EXE}'")

# Check the right clang version (>=12)
execute_process(COMMAND ${MODERN_CLANG_EXE} --version
  OUTPUT_VARIABLE CLANG_version_output
  ERROR_VARIABLE CLANG_version_error
  RESULT_VARIABLE CLANG_version_result
  OUTPUT_STRIP_TRAILING_WHITESPACE
)

if(${CLANG_version_result} EQUAL 0)
  if("${CLANG_version_output}" MATCHES "clang version ([^\n]+)\n")
    # Transform X.Y.Z into X;Y;Z which can then be interpreted as a list
    set(CLANG_VERSION "${CMAKE_MATCH_1}")
    string(REPLACE "." ";" CLANG_VERSION_LIST ${CLANG_VERSION})
    list(GET CLANG_VERSION_LIST 0 CLANG_VERSION_MAJOR)

    string(COMPARE LESS ${CLANG_VERSION_MAJOR} 12 CLANG_VERSION_MAJOR_LT12)

    if(${CLANG_VERSION_MAJOR_LT12})
      message(WARNING "${MODERN_BPF_LOG_PREFIX} clang '${CLANG_VERSION}' is too old for compiling the modern BPF probe, you need at least '12.0.0' version")
    endif()

    message(STATUS "${MODERN_BPF_LOG_PREFIX} Found clang version: ${CLANG_VERSION}")
  else()
    message(WARNING "${MODERN_BPF_LOG_PREFIX} Failed to parse clang version string: ${CLANG_version_output}")
  endif()
else()
  message(FATAL_ERROR "${MODERN_BPF_LOG_PREFIX} Command \"${MODERN_CLANG_EXE} --version\" failed with output:\n ${CLANG_version_error}")
endif()

########################
# Check bpftool version.
########################

# If the user doesn't provide the path to `bpftool` try to find it locally
if(NOT MODERN_BPFTOOL_EXE)
  find_program(MODERN_BPFTOOL_EXE NAMES bpftool DOC "Path to bpftool executable")
  if(NOT MODERN_BPFTOOL_EXE)
    message(FATAL_ERROR "${MODERN_BPF_LOG_PREFIX} unable to find bpftool on the system")
  endif()
endif()

# If it is a relative path we convert it to an absolute one relative to the root source directory.
get_filename_component(MODERN_BPFTOOL_EXE "${MODERN_BPFTOOL_EXE}" REALPATH BASE_DIR "${CMAKE_SOURCE_DIR}")
message(STATUS "${MODERN_BPF_LOG_PREFIX} bpftool used by the modern bpf probe: '${MODERN_BPFTOOL_EXE}'")

# Check the right bpftool version
# Since we want bpftool to have the gen skeleton subcommands and both
# gen and skeleton were added together, we can just grep the help
# output for gen. see:
#   https://lore.kernel.org/bpf/20191210011438.4182911-12-andriin@fb.com/
#
# This is not as strict as checking versions, but it also allows
# compiling on bpftool versions for backported kernels.
execute_process(COMMAND sh -c "${MODERN_BPFTOOL_EXE} help 2>&1 | grep -wq 'gen'"
  OUTPUT_VARIABLE BPFTOOL_version_output
  ERROR_VARIABLE BPFTOOL_version_error
  RESULT_VARIABLE BPFTOOL_version_result
  OUTPUT_STRIP_TRAILING_WHITESPACE
)

if(NOT ${BPFTOOL_version_result} EQUAL 0)
    message(WARNING "${MODERN_BPF_LOG_PREFIX} bpftool does not support gen command")
endif()

########################
# Get clang bpf system includes
########################

execute_process(
  COMMAND bash -c "${MODERN_CLANG_EXE} -v -E - < /dev/null 2>&1 |
          sed -n '/<...> search starts here:/,/End of search list./{ s| \\(/.*\\)|-idirafter \\1|p }'"
  OUTPUT_VARIABLE CLANG_SYSTEM_INCLUDES_output
  ERROR_VARIABLE CLANG_SYSTEM_INCLUDES_error
  RESULT_VARIABLE CLANG_SYSTEM_INCLUDES_result
  OUTPUT_STRIP_TRAILING_WHITESPACE
)

if(${CLANG_SYSTEM_INCLUDES_result} EQUAL 0)
  string(REPLACE "\n" " " CLANG_SYSTEM_INCLUDES "${CLANG_SYSTEM_INCLUDES_output}")
  message(STATUS "${MODERN_BPF_LOG_PREFIX} BPF system include flags: ${CLANG_SYSTEM_INCLUDES}")
else()
  message(FATAL_ERROR "${MODERN_BPF_LOG_PREFIX} Failed to determine BPF system includes: ${CLANG_SYSTEM_INCLUDES_error}")
endif()

########################
# Get target arch
########################

execute_process(COMMAND uname -m
  COMMAND sed "s/x86_64/x86/"
  COMMAND sed "s/aarch64/arm64/"
  COMMAND sed "s/ppc64le/powerpc/"
  COMMAND sed "s/mips.*/mips/"
  COMMAND sed "s/s390x/s390/"
  OUTPUT_VARIABLE ARCH_output
  ERROR_VARIABLE ARCH_error
  RESULT_VARIABLE ARCH_result
  OUTPUT_STRIP_TRAILING_WHITESPACE
)

if(${ARCH_result} EQUAL 0)
  set(ARCH ${ARCH_output})
  message(STATUS "${MODERN_BPF_LOG_PREFIX} Target arch: ${ARCH}")
else()
  message(FATAL_ERROR "${MODERN_BPF_LOG_PREFIX} Failed to determine target architecture: ${ARCH_error}")
endif()

########################
# Set includes and compilation flags
########################

# Get modern probe include.
list(APPEND MODERN_PROBE_INCLUDE "-I${CMAKE_CURRENT_SOURCE_DIR}")

# Note here we use the libs root directory since we want to avoid conflicts between the `bpf` folder inside
# `driver` and the `libbpf` includes.
set(PPM_INCLUDE ${LIBS_DIR})

## Set CLANG FLAGS
set(CLANG_FLAGS "")
list(APPEND CLANG_FLAGS
    -g -O2
    -target bpf
    -D__${DEBUG}__
    -D__TARGET_ARCH_${ARCH} # Match libbpf usage in `/libbpf/src/bpf_tracing.h`
    -D__USE_VMLINUX__ # Used to compile without kernel headers.
    -I${LIBBPF_INCLUDE}
    ${MODERN_PROBE_INCLUDE}
    -I${PPM_INCLUDE}
    -isystem
)

message(STATUS "${MODERN_BPF_LOG_PREFIX} Compilation flags: ${CLANG_FLAGS}")

## Search all bpf includes files. (we can use bpf.h files)
file(GLOB_RECURSE BPF_H_FILES ${CMAKE_CURRENT_SOURCE_DIR}/*.h)

## Search all bpf.c files
file(GLOB_RECURSE BPF_C_FILES ${CMAKE_CURRENT_SOURCE_DIR}/*.bpf.c)

########################
# Generate an `bpf.o` file for every `bpf.c`
########################

foreach(BPF_C_FILE ${BPF_C_FILES})
    get_filename_component(file_stem ${BPF_C_FILE} NAME_WE)

    if(MODERN_BPF_EXCLUDE_PROGS)
        if(${file_stem} MATCHES "${MODERN_BPF_EXCLUDE_PROGS}")
            message(STATUS "Exclude file: ${file_stem}")
            continue()
        endif()
    endif()

    set(BPF_O_FILE ${CMAKE_CURRENT_BINARY_DIR}/${file_stem}.bpf.o)

    add_custom_command(
        OUTPUT ${BPF_O_FILE}
        COMMAND ${MODERN_CLANG_EXE} ${CLANG_FLAGS} ${CLANG_SYSTEM_INCLUDES} -c ${BPF_C_FILE} -o ${BPF_O_FILE}
        VERBATIM
        DEPENDS libbpf
        DEPENDS ${BPF_C_FILE} ${BPF_H_FILES}
        COMMENT "${MODERN_BPF_LOG_PREFIX} Building BPF object: ${BPF_O_FILE}"
    )

    list(APPEND BPF_OBJECT_FILES ${BPF_O_FILE})
endforeach()

########################
# Generate a unique `bpf.o` file
########################

set(UNIQUE_BPF_O_FILE ${CMAKE_CURRENT_BINARY_DIR}/${UNIQUE_BPF_O_FILE_NAME}.o)
add_custom_command(
  OUTPUT ${UNIQUE_BPF_O_FILE}
  COMMAND ${MODERN_BPFTOOL_EXE} gen object ${UNIQUE_BPF_O_FILE} ${BPF_OBJECT_FILES}
  VERBATIM
  DEPENDS ${BPF_OBJECT_FILES}
  COMMENT "${MODERN_BPF_LOG_PREFIX} Building BPF unique object file: ${UNIQUE_BPF_O_FILE}"
)

########################
# Generate the skeleton file
########################

set(BPF_SKEL_FILE ${MODERN_BPF_SKEL_DIR}/${UNIQUE_BPF_O_FILE_NAME}.skel.h)
add_custom_command(
    OUTPUT ${BPF_SKEL_FILE}
    COMMAND bash -c "${MODERN_BPFTOOL_EXE} gen skeleton ${UNIQUE_BPF_O_FILE} > ${BPF_SKEL_FILE}"
    VERBATIM
    DEPENDS ${UNIQUE_BPF_O_FILE}
    COMMENT "${MODERN_BPF_LOG_PREFIX} Building BPF skeleton: ${BPF_SKEL_FILE}"
)

########################
# Add the skeleton as a custom target
########################

add_custom_target(ProbeSkeleton ALL DEPENDS ${BPF_SKEL_FILE})

=== test/drivers/CMakeLists.txt ===
message(STATUS "Drivers tests build enabled")

## Configure ia32 action test
option(ENABLE_IA32_TESTS "Enable ia32 tests. Require ia32 glibc and gcc." ON)
if(ENABLE_IA32_TESTS)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/test_suites/actions_suite/ia32.cpp.in ${CMAKE_CURRENT_SOURCE_DIR}/test_suites/actions_suite/ia32.cpp)
endif()

## Syscall_exit suite files.
file(GLOB_RECURSE SYSCALL_EXIT_TEST_SUITE ${CMAKE_CURRENT_SOURCE_DIR}/test_suites/syscall_exit_suite/*.cpp)

## Syscall_enter suite files.
file(GLOB_RECURSE SYSCALL_ENTER_TEST_SUITE ${CMAKE_CURRENT_SOURCE_DIR}/test_suites/syscall_enter_suite/*.cpp)

## Generic tracepoints suite files.
file(GLOB_RECURSE GENERIC_TRACEPOINTS_TEST_SUITE ${CMAKE_CURRENT_SOURCE_DIR}/test_suites/generic_tracepoints_suite/*.cpp)

## Actions suite files
file(GLOB_RECURSE ACTIONS_TEST_SUITE ${CMAKE_CURRENT_SOURCE_DIR}/test_suites/actions_suite/*.cpp)

include(libscap)

set(DRIVERS_TEST_SOURCES
  ./start_tests.cpp
  ./event_class/event_class.cpp
  ./flags/capabilities.cpp
  ./helpers/proc_parsing.cpp
  ./helpers/file_opener.cpp
  "${SYSCALL_EXIT_TEST_SUITE}"
  "${SYSCALL_ENTER_TEST_SUITE}"
  "${GENERIC_TRACEPOINTS_TEST_SUITE}"
  "${ACTIONS_TEST_SUITE}"
)

set(DRIVERS_TEST_INCLUDE
  PRIVATE
  "${GTEST_INCLUDE}"
  "${LIBS_DIR}/driver/"
  "${LIBSCAP_INCLUDE_DIRS}"
)

set(DRIVERS_TEST_LINK_LIBRARIES
  scap
  "${GTEST_LIB}"
  "${GTEST_MAIN_LIB}"
)

set(DRIVERS_TEST_DEPENDECIES
        scap
        gtest
)

## IA32 tests are only available on x86_64
if(${CMAKE_HOST_SYSTEM_PROCESSOR} STREQUAL "x86_64" AND ENABLE_IA32_TESTS)
    add_executable(ia32 ./helpers/ia32.c)
    set_target_properties(ia32 PROPERTIES COMPILE_FLAGS "-m32" LINK_FLAGS "-m32")
    set(DRIVERS_TEST_DEPENDECIES
            ${DRIVERS_TEST_DEPENDECIES}
            ia32
    )
endif()

add_compile_options(${FALCOSECURITY_LIBS_USERSPACE_COMPILE_FLAGS})
add_link_options(${FALCOSECURITY_LIBS_USERSPACE_LINK_FLAGS})
add_executable(drivers_test ${DRIVERS_TEST_SOURCES})
target_include_directories(drivers_test ${DRIVERS_TEST_INCLUDE})
target_link_libraries(drivers_test ${DRIVERS_TEST_LINK_LIBRARIES})
add_dependencies(drivers_test ${DRIVERS_TEST_DEPENDECIES})

=== test/e2e/CMakeLists.txt ===
# TODO: find a better way to determine if we run ebpf tests or not
if(NOT CMAKE_SYSTEM_NAME MATCHES "Linux")
	return()
endif()

if(NOT BUILD_BPF)
	message(WARNING "e2e tests can only be run with the eBPF probe")
	return()
endif()

set(E2E_CONTEXT ${CMAKE_CURRENT_BINARY_DIR}/ctx)

# When running in CI, dump the reports in /tmp/
if(DEFINED ENV{CI})
    set(E2E_REPORT /tmp/)
else()
    set(E2E_REPORT ${CMAKE_CURRENT_BINARY_DIR})
endif()

add_compile_options(${FALCOSECURITY_LIBS_USERSPACE_COMPILE_FLAGS})
add_link_options(${FALCOSECURITY_LIBS_USERSPACE_LINK_FLAGS})

add_custom_target(e2e-install-deps
	COMMAND pip3 install -r ${CMAKE_CURRENT_SOURCE_DIR}/tests/requirements.txt
	COMMAND pip3 install ${CMAKE_CURRENT_SOURCE_DIR}/tests/commons/
)

add_custom_target(e2e-context
	COMMAND mkdir -p ${E2E_CONTEXT}
	COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_BINARY_DIR}/libsinsp/examples/sinsp-example ${E2E_CONTEXT}
	COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_BINARY_DIR}/driver/scap.ko ${E2E_CONTEXT}
	COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_BINARY_DIR}/driver/bpf/probe.o ${E2E_CONTEXT}
	DEPENDS sinsp-example driver bpf
)

add_custom_target(e2e-containers
	COMMAND docker build
		--tag sinsp-example:latest
		-f ${CMAKE_CURRENT_SOURCE_DIR}/containers/sinsp.Dockerfile
		${E2E_CONTEXT}
	COMMAND docker build
		--tag sinsp-e2e-tester:latest
		-f ${CMAKE_CURRENT_SOURCE_DIR}/containers/tests.Dockerfile
		${CMAKE_CURRENT_SOURCE_DIR}
	DEPENDS e2e-context
)

add_custom_target(e2e-tests-container
	COMMAND mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/report
	# Run e2e tests with the kernel module
	COMMAND docker run --rm
		--name sinsp-e2e-tester
		-e KERNEL_MODULE=/driver/scap.ko
		-e BPF_PROBE=/driver/probe.o
		-v /var/run/docker.sock:/var/run/docker.sock
		-v ${E2E_REPORT}/report:/report
		sinsp-e2e-tester:latest
	DEPENDS e2e-containers
)

add_custom_target(e2e-tests
	COMMAND mkdir -p ${E2E_REPORT}/report
	# Run e2e tests with the kernel module
	COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/scripts/run_tests.sh
	DEPENDS sinsp-example driver bpf
)

# This is a list of containers run by the e2e tests, if you add a different one
# please add it to the list
set(E2E_CONTAINERS
	sinsp
	nginx
	sinsp-e2e-tester
	curl
	generator
	http-hello
)

 add_custom_target(e2e-cleanup
	 COMMAND docker rm -f ${E2E_CONTAINERS}
)

=== test/libscap/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
#
# Copyright (C) 2023 The Falco Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

message(STATUS "Libscap unit tests build enabled")

if(NOT DEFINED DRIVER_NAME)
	set(DRIVER_NAME "scap")
endif()

# Create a libscap_test_var.h file with some variables used by our tests
# for example the kmod path or the bpf path.
configure_file (
    "${CMAKE_CURRENT_SOURCE_DIR}/libscap_test_var.h.in"
    "${CMAKE_CURRENT_BINARY_DIR}/libscap_test_var.h"
)

set(LIBSCAP_TESTS_INCLUDE
  PRIVATE
  "${GTEST_INCLUDE}"
  "${CMAKE_CURRENT_SOURCE_DIR}" # for test helpers <helpers/...>
  "${LIBS_DIR}"
  "${LIBS_DIR}/userspace"
  "${PROJECT_BINARY_DIR}"
  "${CMAKE_CURRENT_BINARY_DIR}" # used to include `libscap_test_var.h`
)

# Needed by gtest
find_package(Threads)

set(LIBSCAP_TESTS_LIBRARIES
	"${GTEST_LIB}"
	"${GTEST_MAIN_LIB}"
	"${CMAKE_THREAD_LIBS_INIT}"
	scap
)

# Add `gcov` to needed libraries
if (CMAKE_BUILD_TYPE STREQUAL "Coverage")
	list(APPEND LIBSCAP_TESTS_LIBRARIES gcov)
endif()

set(LIBSCAP_TESTS_DEPENDENCIES
	gtest
	scap
)

# Test suite asserting against pure userspace components
file(GLOB_RECURSE USERSPACE_TEST_SUITE "${CMAKE_CURRENT_SOURCE_DIR}/test_suites/userspace/*.cpp")
set(LIBSCAP_TESTS_SOURCES ${USERSPACE_TEST_SUITE})

# Helpers are not engine-specific so we always include them
file(GLOB_RECURSE LIBSCAP_TESTS_UTILS_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/helpers/*cpp")
list(APPEND LIBSCAP_TESTS_SOURCES ${LIBSCAP_TESTS_UTILS_SOURCES})

# Linux specific tests
if (CMAKE_SYSTEM_NAME MATCHES "Linux")
	file(GLOB_RECURSE LINUX_TEST_SUITE "${CMAKE_CURRENT_SOURCE_DIR}/test_suites/userspace/linux/*.cpp")
	list(APPEND LIBSCAP_TEST_SOURCES ${LINUX_TEST_SUITE})
	list(APPEND LIBSCAP_TESTS_LIBRARIES scap_engine_util)
endif()

# Engine-specific tests
if(BUILD_DRIVER)
	file(GLOB_RECURSE KMOD_TEST_SUITE "${CMAKE_CURRENT_SOURCE_DIR}/test_suites/engines/kmod/*.cpp")
	list(APPEND LIBSCAP_TESTS_SOURCES ${KMOD_TEST_SUITE})
	# Set `driver` target as a dependency
	list(APPEND LIBSCAP_TESTS_DEPENDENCIES driver)
endif()

if(BUILD_BPF)
	file(GLOB_RECURSE BPF_TEST_SUITE "${CMAKE_CURRENT_SOURCE_DIR}/test_suites/engines/bpf/*.cpp")
	list(APPEND LIBSCAP_TESTS_SOURCES ${BPF_TEST_SUITE})
	# Set `bpf` target as a dependency
	list(APPEND LIBSCAP_TESTS_DEPENDENCIES bpf)
endif()

if(BUILD_LIBSCAP_MODERN_BPF)
	file(GLOB_RECURSE MODERN_BPF_TEST_SUITE "${CMAKE_CURRENT_SOURCE_DIR}/test_suites/engines/modern_bpf/*.cpp")
	list(APPEND LIBSCAP_TESTS_SOURCES ${MODERN_BPF_TEST_SUITE})
endif()

if(BUILD_LIBSCAP_GVISOR)
	include(protobuf)
	file(GLOB_RECURSE GVISOR_TEST_SUITE "${CMAKE_CURRENT_SOURCE_DIR}/test_suites/engines/gvisor/*.cpp")
	list(APPEND LIBSCAP_TESTS_SOURCES ${GVISOR_TEST_SUITE})
	list(APPEND LIBSCAP_TESTS_INCLUDE "${CMAKE_BINARY_DIR}/libscap/engine/gvisor") # Used for <pkg/sentry/...> includes
endif()

# Summary logs
set(LIBSCAP_UNIT_TESTS_PREFIX "[LIBSCAP UNIT TESTS]")
message(STATUS "${LIBSCAP_UNIT_TESTS_PREFIX} LIBSCAP_TESTS_SOURCES: ${LIBSCAP_TESTS_SOURCES}")
message(STATUS "${LIBSCAP_UNIT_TESTS_PREFIX} LIBSCAP_TESTS_INCLUDE: ${LIBSCAP_TESTS_INCLUDE}")
message(STATUS "${LIBSCAP_UNIT_TESTS_PREFIX} LIBSCAP_TESTS_LIBRARIES: ${LIBSCAP_TESTS_LIBRARIES}")
message(STATUS "${LIBSCAP_UNIT_TESTS_PREFIX} LIBSCAP_TESTS_DEPENDENCIES: ${LIBSCAP_TESTS_DEPENDENCIES}")

add_compile_options(${FALCOSECURITY_LIBS_USERSPACE_COMPILE_FLAGS})
add_link_options(${FALCOSECURITY_LIBS_USERSPACE_LINK_FLAGS})
add_executable(libscap_test ${LIBSCAP_TESTS_SOURCES})
target_include_directories(libscap_test ${LIBSCAP_TESTS_INCLUDE})
target_link_libraries(libscap_test ${LIBSCAP_TESTS_LIBRARIES})
add_dependencies(libscap_test ${LIBSCAP_TESTS_DEPENDENCIES})

=== test/libsinsp_e2e/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
#
# Copyright (C) 2024 The Falco Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

message(STATUS "Libsinsp unit e2e tests build enabled")

if(NOT DEFINED DRIVER_NAME)
    set(DRIVER_NAME "scap")
endif()

add_compile_options(${FALCOSECURITY_LIBS_USERSPACE_COMPILE_FLAGS})
add_link_options(${FALCOSECURITY_LIBS_USERSPACE_LINK_FLAGS})

# Create a libsinsp_test_var.h file with some variables used by our tests
# for example the kmod path or the bpf path.
configure_file (
    "${CMAKE_CURRENT_SOURCE_DIR}/libsinsp_test_var.h.in"
    "${CMAKE_CURRENT_BINARY_DIR}/libsinsp_test_var.h"
)

add_executable(libsinsp_e2e_tests
    container/container.cpp
    container/container_cgroup.cpp
    container/docker_utils.cpp
    event_capture.cpp
    main.cpp
    subprocess.cpp
    sys_call_test.cpp
    thread_state.cpp
)

if(BUILD_BPF)
    add_dependencies(libsinsp_e2e_tests driver bpf)
else()
    add_dependencies(libsinsp_e2e_tests driver)
endif()

target_link_libraries(libsinsp_e2e_tests
    sinsp
    GTest::gtest
    pthread
)

target_include_directories(libsinsp_e2e_tests
    PRIVATE
    ${PROJECT_BINARY_DIR}/driver/src
    "${CMAKE_CURRENT_BINARY_DIR}" # used to include `libsinsp_test_var.h`
)

add_executable(test_helper test_helper.cpp)
target_link_libraries(test_helper pthread)
add_dependencies(libsinsp_e2e_tests test_helper)

add_executable(vtidcollision vtidcollision.c)
add_dependencies(libsinsp_e2e_tests vtidcollision)

execute_process(
    COMMAND "uname" "-m"
    OUTPUT_VARIABLE ARCH
    OUTPUT_STRIP_TRAILING_WHITESPACE
)

if("${CMAKE_SIZEOF_VOID_P}" EQUAL "8")
    # Build 32-bit tests only for architectures where that is supported
    if(${CMAKE_HOST_SYSTEM_PROCESSOR} STREQUAL "x86_64")
        add_executable(test_helper_32 test_helper.cpp)
        set_target_properties(test_helper_32 PROPERTIES COMPILE_FLAGS "-m32" LINK_FLAGS "-m32")
        target_link_libraries(test_helper_32 pthread)
        add_dependencies(libsinsp_e2e_tests test_helper_32)
    endif()
endif("${CMAKE_SIZEOF_VOID_P}" EQUAL "8")

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/test_helper.sh ${CMAKE_CURRENT_BINARY_DIR}/test_helper.sh COPYONLY
)

file(COPY
    ${CMAKE_CURRENT_SOURCE_DIR}/resources/
    DESTINATION
    ${CMAKE_CURRENT_BINARY_DIR}/resources/
)

=== test/vm/CMakeLists.txt ===
set(UBUNTU_CONTAINER1 "vm-ubuntu2004:latest")
set(UBUNTU_CONTAINER2 "vm-ubuntu2204:latest")
set(UBUNTU_CONTAINER3 "vm-ubuntu2310:latest")
set(DEBIANBUSTER_CONTAINER "vm-debianbuster:latest")
# TODO In case we have an equivalent upstream supported container, remove the custom modern-falco-builder
set(MODERN_FALCO_BUILDER_CONTAINER "modern-falco-builder:latest")
set(VM_PROVIDER_VBOX "virtualbox")
set(VM_NAMES_VBOX_VAGRANT_CENTOS7 "centos7")
set(VM_NAMES_VBOX_VAGRANT_UBUNTU "ubuntu")
set(VM_NAMES_VBOX_VAGRANT_AMAZONLINUX2 "amazonlinux2")
set(VM_NAMES_VBOX_VAGRANT "centos7 ubuntu amazonlinux2") # needs to be one string

set(VM_CONTAINERS
	${UBUNTU_CONTAINER1} 
	${UBUNTU_CONTAINER2} 
	${UBUNTU_CONTAINER3} 
	${DEBIANBUSTER_CONTAINER} 
	${MODERN_FALCO_BUILDER_CONTAINER}
)

add_custom_target(vm-dependency-check
	COMMAND bash ${CMAKE_CURRENT_SOURCE_DIR}/scripts/dependency_check.sh;
)

add_custom_target(vm-container
	COMMAND time docker build -f ${CMAKE_CURRENT_SOURCE_DIR}/containers/ubuntu2004.Dockerfile -t ${UBUNTU_CONTAINER1} .;
	COMMAND time docker build -f ${CMAKE_CURRENT_SOURCE_DIR}/containers/ubuntu2204.Dockerfile  -t ${UBUNTU_CONTAINER2} .;
	COMMAND time docker build -f ${CMAKE_CURRENT_SOURCE_DIR}/containers/ubuntu2310.Dockerfile  -t ${UBUNTU_CONTAINER3} .;
	COMMAND time docker build -f ${CMAKE_CURRENT_SOURCE_DIR}/containers/debianbuster.Dockerfile  -t ${DEBIANBUSTER_CONTAINER} .;
	COMMAND time docker build -f ${CMAKE_CURRENT_SOURCE_DIR}/containers/modern-falco-builder.Dockerfile  -t ${MODERN_FALCO_BUILDER_CONTAINER} .;
)

add_custom_target(vm-kernel
	COMMAND mkdir -p ${CMAKE_CURRENT_SOURCE_DIR}/build;
	COMMAND time docker run -v ${CMAKE_CURRENT_SOURCE_DIR}:/vm:z ${UBUNTU_CONTAINER2} '/bin/bash /vm/scripts/kernel_download.sh /vm/build /vm/kernels.jsonl';
	COMMAND time docker run -v ${CMAKE_CURRENT_SOURCE_DIR}:/vm:z ${UBUNTU_CONTAINER2} '/bin/bash /vm/scripts/kernel_extract.sh /vm/build/headers /vm/build/headers_extracted';
	DEPENDS vm-container
)

# Prepares containers, kernel packages and VMs for vm-tests - typically run once
add_custom_target(vm-init
	COMMAND time bash ${CMAKE_CURRENT_SOURCE_DIR}/scripts/vm_init.sh ${CMAKE_CURRENT_SOURCE_DIR} ${VM_PROVIDER_VBOX} ${VM_NAMES_VBOX_VAGRANT};
	DEPENDS vm-kernel
)

# Main test to build scap-open and each driver for array of compiler versions
add_custom_target(vm-compile
	COMMAND time bash ${CMAKE_CURRENT_SOURCE_DIR}/scripts/vm_compile.sh ${CMAKE_CURRENT_SOURCE_DIR};
	COMMAND time bash ${CMAKE_CURRENT_SOURCE_DIR}/scripts/vm_result.sh ${CMAKE_CURRENT_SOURCE_DIR} ${UBUNTU_CONTAINER2};
)

# Loop over centos7 kernels
add_custom_target(vm-centos7
	COMMAND time bash -c 'bash ${CMAKE_CURRENT_SOURCE_DIR}/scripts/vagrant_loop.sh ${CMAKE_CURRENT_SOURCE_DIR} ${VM_PROVIDER_VBOX} ${VM_NAMES_VBOX_VAGRANT_CENTOS7}';
	COMMAND time bash ${CMAKE_CURRENT_SOURCE_DIR}/scripts/vm_result.sh ${CMAKE_CURRENT_SOURCE_DIR} ${UBUNTU_CONTAINER2};
)

# Loop over ubuntu kernels
add_custom_target(vm-ubuntu
	COMMAND time bash -c 'bash ${CMAKE_CURRENT_SOURCE_DIR}/scripts/vagrant_loop.sh ${CMAKE_CURRENT_SOURCE_DIR} ${VM_PROVIDER_VBOX} ${VM_NAMES_VBOX_VAGRANT_UBUNTU}';
	COMMAND time bash ${CMAKE_CURRENT_SOURCE_DIR}/scripts/vm_result.sh ${CMAKE_CURRENT_SOURCE_DIR} ${UBUNTU_CONTAINER2};
)

# Loop over amazonlinux2 kernels, less stable, can have issues recovering from failed kmod tests
add_custom_target(vm-amazonlinux2
	COMMAND time bash -c 'bash ${CMAKE_CURRENT_SOURCE_DIR}/scripts/vagrant_loop.sh ${CMAKE_CURRENT_SOURCE_DIR} ${VM_PROVIDER_VBOX} ${VM_NAMES_VBOX_VAGRANT_AMAZONLINUX2}';
	COMMAND time bash ${CMAKE_CURRENT_SOURCE_DIR}/scripts/vm_result.sh ${CMAKE_CURRENT_SOURCE_DIR} ${UBUNTU_CONTAINER2};
)

# Create result tables
add_custom_target(vm-result
	COMMAND time bash ${CMAKE_CURRENT_SOURCE_DIR}/scripts/vm_result.sh ${CMAKE_CURRENT_SOURCE_DIR} ${UBUNTU_CONTAINER2};
)

add_custom_target(vm-cleanup
	COMMAND docker rm -f ${VM_CONTAINERS};
	COMMAND docker image rm -f ${VM_CONTAINERS};
	COMMAND bash ${CMAKE_CURRENT_SOURCE_DIR}/scripts/vm_cleanup.sh ${CMAKE_CURRENT_SOURCE_DIR} ${VM_PROVIDER_VBOX};
)

=== userspace/libpman/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
#
# Copyright (C) 2023 The Falco Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

add_compile_options(${FALCOSECURITY_LIBS_USERSPACE_COMPILE_FLAGS})
add_link_options(${FALCOSECURITY_LIBS_USERSPACE_LINK_FLAGS})

add_library(pman
    src/stats.c
    src/maps.c
    src/lifecycle.c
    src/programs.c
    src/ringbuffer.c
    src/configuration.c
    src/state.c
    src/sc_set.c
)

target_include_directories(pman
PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>
    $<BUILD_INTERFACE:${LIBS_DIR}>           # ppm_enum and tables
    $<BUILD_INTERFACE:${LIBS_DIR}/userspace> # scap-stats struct
    ${ZLIB_INCLUDE}
    ${LIBBPF_INCLUDE}
    ${MODERN_BPF_SKEL_DIR}
    ${LIBELF_INCLUDE}
)

target_link_libraries(pman
PUBLIC
    scap_event_schema
    scap_platform
    ${LIBBPF_LIB}
    ${LIBELF_LIB}
    ${ZLIB_LIB}
)

if (TARGET ProbeSkeleton)
    add_dependencies(pman ProbeSkeleton)
endif()

if(USE_BUNDLED_LIBBPF)
    add_dependencies(pman libbpf)
endif()

=== userspace/libscap/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
#
# Copyright (C) 2023 The Falco Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

include(engine_config)

option(USE_BUNDLED_DEPS "Enable bundled dependencies instead of using the system ones" ON)

include(ExternalProject)

include(zlib)

add_definitions(-DPLATFORM_NAME="${CMAKE_SYSTEM_NAME}")
add_compile_options(${FALCOSECURITY_LIBS_USERSPACE_COMPILE_FLAGS})
add_link_options(${FALCOSECURITY_LIBS_USERSPACE_LINK_FLAGS})

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
	if(CMAKE_BUILD_TYPE STREQUAL "Debug")
		set(KBUILD_FLAGS "${FALCOSECURITY_LIBS_DEBUG_FLAGS}")
	endif()

	# do not remove this since when WITH_DRIVER is off
	if(NOT DEFINED DRIVER_NAME)
		set(DRIVER_NAME "scap")
	endif()

	string(REPLACE "-" "_" SCAP_KERNEL_MODULE_NAME "${DRIVER_NAME}")
	add_definitions(-DSCAP_KERNEL_MODULE_NAME="${SCAP_KERNEL_MODULE_NAME}")
endif()

if(NOT DEFINED SCAP_HOST_ROOT_ENV_VAR_NAME)
	set(SCAP_HOST_ROOT_ENV_VAR_NAME "HOST_ROOT")
endif()
add_definitions(-DSCAP_HOST_ROOT_ENV_VAR_NAME="${SCAP_HOST_ROOT_ENV_VAR_NAME}")

if(NOT DEFINED SCAP_HOSTNAME_ENV_VAR)
	set(SCAP_HOSTNAME_ENV_VAR "SCAP_HOSTNAME")
endif()
add_definitions(-DSCAP_HOSTNAME_ENV_VAR="${SCAP_HOSTNAME_ENV_VAR}")

if (DEFINED SCAP_BPF_PROGS_TAIL_CALLED_MAX)
	add_definitions(-DBPF_PROGS_TAIL_CALLED_MAX=${SCAP_BPF_PROGS_TAIL_CALLED_MAX})
endif()


configure_file(${CMAKE_CURRENT_SOURCE_DIR}/scap_strl_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/scap_strl_config.h)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/scap_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/scap_config.h)


add_library(scap_error STATIC strerror.c)

target_include_directories(scap_error PUBLIC $<BUILD_INTERFACE:${LIBS_DIR}/userspace>)

add_library(scap
	scap.c
	scap_api_version.c
	scap_savefile.c
	scap_platform_api.c
)

target_include_directories(scap
PUBLIC
	$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
	$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
	$<INSTALL_INTERFACE:${CMAKE_INSTALL_PREFIX}/include/${LIBS_PACKAGE_NAME}>
)

set_scap_target_properties(scap)

add_library(scap_platform_util STATIC
	scap_platform.c
	scap_fds.c
	scap_iflist.c
	scap_proc_util.c
	scap_procs.c
	scap_userlist.c
)
add_dependencies(scap_platform_util uthash)

target_include_directories(scap_platform_util
PUBLIC
	$<BUILD_INTERFACE:${LIBS_DIR}>
	$<BUILD_INTERFACE:${LIBS_DIR}/userspace>
	$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
)

target_link_libraries(scap
PRIVATE
	scap_error
	"${ZLIB_LIB}"
)

add_library(scap_event_schema STATIC
	scap_event.c
	ppm_sc_names.c
	${LIBS_DIR}/driver/dynamic_params_table.c
	${LIBS_DIR}/driver/event_table.c
	${LIBS_DIR}/driver/flags_table.c
	${LIBS_DIR}/driver/syscall_table64.c
	${LIBS_DIR}/driver/syscall_ia32_64_map.c
	linux/scap_ppm_sc.c
)

add_dependencies(scap_event_schema uthash)

target_include_directories(scap_event_schema
PUBLIC
	$<BUILD_INTERFACE:${LIBS_DIR}>
	$<BUILD_INTERFACE:${LIBS_DIR}/userspace>
	$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
)

target_link_libraries(scap PUBLIC scap_event_schema)

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
	option(BUILD_LIBSCAP_EXAMPLES "Build libscap examples" ON)
	include(FindMakedev)

	add_subdirectory(linux)
	target_link_libraries(scap PUBLIC scap_platform)


	add_library(driver_event_schema STATIC
		${LIBS_DIR}/driver/fillers_table.c)

	target_link_libraries(scap_event_schema driver_event_schema)


	add_library(scap_engine_util STATIC
		scap_engine_util.c
		ringbuffer/devset.c
		ringbuffer/ringbuffer.c
	)
	add_dependencies(scap_engine_util uthash)
	target_include_directories(scap_engine_util
	PUBLIC
		$<BUILD_INTERFACE:${LIBS_DIR}>
		$<BUILD_INTERFACE:${LIBS_DIR}/userspace>
		$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
	)
	target_link_libraries(scap PRIVATE scap_engine_util)
endif()


################## LISCAP ENGINES ##################

add_subdirectory(engine/noop)
# don't link the noop engine to libscap directly,
# it's a helper library for other engines (it's completely useless on its own)

if(HAS_ENGINE_NODRIVER)
	add_subdirectory(engine/nodriver)
	target_link_libraries(scap PUBLIC scap_engine_nodriver)
endif()

if(HAS_ENGINE_TEST_INPUT)
	# Add engine only used for testing
	add_subdirectory(engine/test_input)
	target_link_libraries(scap PUBLIC scap_engine_test_input)
endif()

if(HAS_ENGINE_SAVEFILE)
	add_subdirectory(engine/savefile)
	target_link_libraries(scap PUBLIC scap_engine_savefile)
endif()

if(HAS_ENGINE_SOURCE_PLUGIN)
	add_subdirectory(engine/source_plugin)
	target_link_libraries(scap PUBLIC scap_engine_source_plugin)
endif()

if(HAS_ENGINE_KMOD)
	add_subdirectory(engine/kmod)
	target_link_libraries(scap PUBLIC scap_engine_kmod)
	target_include_directories(scap_engine_kmod
	PRIVATE
		${PROJECT_BINARY_DIR}/driver/src
	)
endif()

if(HAS_ENGINE_BPF)
	include(libelf)
	add_subdirectory(engine/bpf)
	target_link_libraries(scap PUBLIC scap_engine_bpf)
	target_include_directories(scap_engine_bpf
	PRIVATE
		${PROJECT_BINARY_DIR}/driver/src
	)
endif()

if(HAS_ENGINE_MODERN_BPF)
	include(libelf)
	add_subdirectory(engine/modern_bpf)
	target_link_libraries(scap PUBLIC scap_engine_modern_bpf)
	target_include_directories(scap_engine_modern_bpf
	PRIVATE
		${PROJECT_BINARY_DIR}/driver/src
	)
endif()

if(HAS_ENGINE_GVISOR)
	add_subdirectory(engine/gvisor)
	# The static and shared build differs here because a shared scap_engine_gvisor
	# will result in circular dependencies.
	if(BUILD_SHARED_LIBS)
		# We can move this to the gvisor CMakeFile when we use
		# CMake 3.13 or later.
		# https://cmake.org/cmake/help/latest/policy/CMP0079.html
		target_link_libraries(scap
		PRIVATE
			${CMAKE_THREAD_LIBS_INIT}
			${PROTOBUF_LIB}
			${JSONCPP_LIB}
		)
	else()
		target_link_libraries(scap PRIVATE scap_engine_gvisor)
	endif()
endif()

####################################################

if (BUILD_LIBSCAP_EXAMPLES)
	add_subdirectory(examples/01-open)
	add_subdirectory(examples/02-validatebuffer)
endif()

=== userspace/libsinsp/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
#
# Copyright (C) 2023 The Falco Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

option(USE_BUNDLED_DEPS "Enable bundled dependencies instead of using the system ones" ON)

if(NOT MSVC)
	add_definitions(-DHAVE_PWD_H)
	add_definitions(-DHAVE_GRP_H)
	if(MUSL_OPTIMIZED_BUILD)
		add_definitions(-DMUSL_OPTIMIZED)
	endif()

	add_compile_options(${FALCOSECURITY_LIBS_USERSPACE_COMPILE_FLAGS})
	add_link_options(${FALCOSECURITY_LIBS_USERSPACE_LINK_FLAGS})
endif()

if(NOT DEFINED CHISEL_TOOL_LIBRARY_NAME)
	set(CHISEL_TOOL_LIBRARY_NAME "sinsp")
endif()
add_definitions(-DCHISEL_TOOL_LIBRARY_NAME="${CHISEL_TOOL_LIBRARY_NAME}")

include(ExternalProject)

include(jsoncpp)
if(WITH_CHISEL)
	include(luajit)
endif()

include(zlib)

if(NOT MINIMAL_BUILD)
	if (NOT WIN32 AND NOT EMSCRIPTEN)
		include(curl)
		include(cares)
	endif() # NOT WIN32
endif()

if(NOT WIN32 AND NOT APPLE )
	if(NOT MINIMAL_BUILD AND NOT EMSCRIPTEN)
		include(grpc)
		include(protobuf)
		include(openssl)
	endif() # NOT MINIMAL_BUILD
endif()

if (NOT EMSCRIPTEN)
	include(tbb)
endif()

add_library(sinsp
	filter/ast.cpp
	filter/escaping.cpp
	filter/parser.cpp
	filter/ppm_codes.cpp
	container.cpp
	container_engine/container_engine_base.cpp
	container_engine/static_container.cpp
	container_info.cpp
	sinsp_cycledumper.cpp
	event.cpp
	eventformatter.cpp
	dns_manager.cpp
	dumper.cpp
	fdinfo.cpp
	filter.cpp
	sinsp_filtercheck.cpp
	sinsp_filtercheck_container.cpp
	sinsp_filtercheck_event.cpp
	sinsp_filtercheck_evtin.cpp
	sinsp_filtercheck_fd.cpp
	sinsp_filtercheck_fdlist.cpp
	sinsp_filtercheck_fspath.cpp
	sinsp_filtercheck_gen_event.cpp
	sinsp_filtercheck_group.cpp
	sinsp_filtercheck_k8s.cpp
	sinsp_filtercheck_mesos.cpp
	sinsp_filtercheck_rawstring.cpp
	sinsp_filtercheck_reference.cpp
	sinsp_filtercheck_syslog.cpp
	sinsp_filtercheck_thread.cpp
	sinsp_filtercheck_tracer.cpp
	sinsp_filtercheck_user.cpp
	sinsp_filtercheck_utils.cpp
	filter_check_list.cpp
	ifinfo.cpp
	memmem.cpp
	metrics_collector.cpp
	logger.cpp
	parsers.cpp
	${LIBS_DIR}/userspace/plugin/plugin_loader.c
	plugin.cpp
	plugin_table_api.cpp
	plugin_filtercheck.cpp
	prefix_search.cpp
	sinsp_syslog.cpp
	threadinfo.cpp
	tuples.cpp
	sinsp.cpp
	token_bucket.cpp
	utils.cpp
	value_parser.cpp
	user.cpp
	gvisor_config.cpp
	sinsp_suppress.cpp
	events/sinsp_events.cpp
	events/sinsp_events_ppm_sc.cpp
)

if(NOT WIN32 AND NOT APPLE)
	target_sources(sinsp PRIVATE procfs_utils.cpp sinsp_cgroup.cpp)
endif()

if(WITH_CHISEL)
	target_sources(sinsp
	PRIVATE
		${LIBS_DIR}/userspace/chisel/chisel_api.cpp
		${LIBS_DIR}/userspace/chisel/chisel_fields_info.cpp
		${LIBS_DIR}/userspace/chisel/chisel_utils.cpp
		${LIBS_DIR}/userspace/chisel/chisel.cpp
		${LIBS_DIR}/userspace/chisel/chisel_viewinfo.cpp
		${LIBS_DIR}/userspace/chisel/chisel_table.cpp
	)
endif()

if(NOT MINIMAL_BUILD AND NOT EMSCRIPTEN)
	target_sources(sinsp
	PRIVATE
		container_engine/docker/async_source.cpp
		container_engine/docker/base.cpp
	)
	if(NOT WIN32)
		target_sources(sinsp
		PRIVATE
			container_engine/docker/docker_linux.cpp
			container_engine/docker/connection_linux.cpp
			container_engine/docker/podman.cpp
			container_engine/libvirt_lxc.cpp
			container_engine/lxc.cpp
			container_engine/mesos.cpp
			container_engine/rkt.cpp
			container_engine/bpm.cpp
			cri_settings.cpp
			runc.cpp
		)
	endif()

	if(NOT WIN32 AND NOT APPLE)
		target_sources(sinsp
		PRIVATE
			cgroup_limits.cpp
			container_engine/cri.cpp
			grpc_channel_registry.cpp
		)
	endif()
endif()

target_include_directories(sinsp
PUBLIC
	$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
	$<BUILD_INTERFACE:${LIBS_DIR}/userspace>
	$<INSTALL_INTERFACE:${CMAKE_INSTALL_PREFIX}/include/${LIBS_PACKAGE_NAME}>
)

if (EMSCRIPTEN)
	target_compile_options(sinsp PRIVATE "-sDISABLE_EXCEPTION_CATCHING=0")
endif()

set_sinsp_target_properties(sinsp)

target_link_libraries(sinsp
		PUBLIC scap
		PRIVATE
			"${CURL_LIBRARIES}"
			"${JSONCPP_LIB}"
			"${RE2_LIB}"
)

set(SINSP_PKGCONFIG_LIBRARIES
	scap
	"${ZLIB_LIB}"
	"${CURL_LIBRARIES}"
	"${JSONCPP_LIB}"
	"${RE2_LIB}"
)

if(NOT EMSCRIPTEN)
	target_link_libraries(sinsp
		INTERFACE
			"${CARES_LIB}"
		PRIVATE
		"${TBB_LIB}"
	)
	list(APPEND SINSP_PKGCONFIG_LIBRARIES "${CARES_LIB}")
endif()

if(USE_BUNDLED_VALIJSON)
	add_dependencies(sinsp valijson)
endif()

if(USE_BUNDLED_RE2)
	add_dependencies(sinsp re2)
endif()

if(USE_BUNDLED_JSONCPP)
	add_dependencies(sinsp jsoncpp)
endif()

if(WITH_CHISEL)
	add_dependencies(sinsp luajit)
endif()

function(prepare_cri_grpc api_version)
	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cri-${api_version}.proto ${CMAKE_CURRENT_BINARY_DIR}/cri-${api_version}.proto COPYONLY)
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/cri-${api_version}.grpc.pb.cc
			${CMAKE_CURRENT_BINARY_DIR}/cri-${api_version}.grpc.pb.h
			${CMAKE_CURRENT_BINARY_DIR}/cri-${api_version}.pb.cc
			${CMAKE_CURRENT_BINARY_DIR}/cri-${api_version}.pb.h
			COMMENT "Generate CRI grpc code for API version ${api_version}"
			DEPENDS
			COMMAND ${PROTOC} -I ${CMAKE_CURRENT_BINARY_DIR} --cpp_out=. ${CMAKE_CURRENT_BINARY_DIR}/cri-${api_version}.proto
			COMMAND ${PROTOC} -I ${CMAKE_CURRENT_BINARY_DIR} --grpc_out=. --plugin=protoc-gen-grpc=${GRPC_CPP_PLUGIN} ${CMAKE_CURRENT_BINARY_DIR}/cri-${api_version}.proto
			WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
	add_library(cri_${api_version} STATIC ${CMAKE_CURRENT_BINARY_DIR}/cri-${api_version}.pb.cc ${CMAKE_CURRENT_BINARY_DIR}/cri-${api_version}.grpc.pb.cc)
	target_include_directories(cri_${api_version}
	PUBLIC
		$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
	)
	add_dependencies(cri_${api_version} grpc)
endfunction()

if (NOT EMSCRIPTEN)
	add_dependencies(sinsp tbb)
endif()

if(NOT WIN32)
	if(NOT MINIMAL_BUILD)
		if(NOT EMSCRIPTEN)
			add_dependencies(sinsp openssl curl)
		endif()
	endif()

	if(NOT APPLE)
		if(NOT MINIMAL_BUILD AND NOT EMSCRIPTEN)
			include(protobuf)
			include(cares)
			prepare_cri_grpc(v1alpha2)
			prepare_cri_grpc(v1)

			target_link_libraries(sinsp
					PRIVATE
						cri_v1alpha2
						cri_v1
					INTERFACE
						"${GRPC_LIBRARIES}"
						"${GRPCPP_LIB}"
						"${GRPC_LIB}"
						"${GPR_LIB}"
						"${PROTOBUF_LIB}"
						"${CARES_LIB}"
			)
			list(APPEND SINSP_PKGCONFIG_LIBRARIES
						"${GRPC_LIBRARIES}"
						"${GRPCPP_LIB}"
						"${GRPC_LIB}"
						"${GPR_LIB}"
						"${PROTOBUF_LIB}"
						"${CARES_LIB}"
			)

			if(NOT MUSL_OPTIMIZED_BUILD)
				target_link_libraries(sinsp INTERFACE rt anl)
				list(APPEND SINSP_PKGCONFIG_LIBRARIES rt anl)
			endif()

		else()
			target_link_libraries(sinsp INTERFACE rt)
			list(APPEND SINSP_PKGCONFIG_LIBRARIES rt)
		endif() # NOT MINIMAL_BUILD
	endif() # NOT APPLE

	target_link_libraries(sinsp INTERFACE "${OPENSSL_LIBRARIES}")
	list(APPEND SINSP_PKGCONFIG_LIBRARIES "${OPENSSL_LIBRARIES}")

	if(WITH_CHISEL)
		target_link_libraries(sinsp INTERFACE "${LUAJIT_LIB}")
		list(APPEND SINSP_PKGCONFIG_LIBRARIES "${LUAJIT_LIB}")
	endif()

	target_link_libraries(sinsp INTERFACE dl pthread)
	list(APPEND SINSP_PKGCONFIG_LIBRARIES dl pthread)

	if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
		if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.0)
			target_link_libraries(sinsp INTERFACE stdc++fs)
			list(APPEND SINSP_PKGCONFIG_LIBRARIES stdc++fs)
		endif()
	endif()
else()
	if(WITH_CHISEL)
		target_link_libraries(sinsp INTERFACE "${LUAJIT_LIB}")
		list(APPEND SINSP_PKGCONFIG_LIBRARIES "${LUAJIT_LIB}")
	endif()
endif() # NOT WIN32

if(APPLE)
	target_link_libraries(sinsp PRIVATE "-framework CoreFoundation")
	target_link_libraries(sinsp PRIVATE "-framework SystemConfiguration")
	set_target_properties(sinsp PROPERTIES LINK_FLAGS "-Wl,-F/Library/Frameworks")
endif()

option(CREATE_TEST_TARGETS "Enable make-targets for unit testing" ON)

if(CREATE_TEST_TARGETS)
		# Add unit test directories
		add_subdirectory(test)
endif()

option(BUILD_LIBSINSP_EXAMPLES "Build libsinsp examples" ON)
if (BUILD_LIBSINSP_EXAMPLES)
	add_subdirectory(examples)
	add_subdirectory(sinsp_debug)
endif()

if(NOT DEFINED SINSP_AGENT_CGROUP_MEM_PATH_ENV_VAR)
	set(SINSP_AGENT_CGROUP_MEM_PATH_ENV_VAR "AGENT_CGROUP_MEM_PATH")
endif()
add_definitions(-DSINSP_AGENT_CGROUP_MEM_PATH_ENV_VAR="${SINSP_AGENT_CGROUP_MEM_PATH_ENV_VAR}")

# Build our pkg-config "Libs:" flags. For now, loop over SINSP_PKGCONFIG_LIBRARIES. If
# we ever start using pkg_search_module or pkg_check_modules in cmake/modules
# we could add each module to our "Requires:" line instead. We might need to
# expand this to use some of the techniques in
# https://github.com/curl/curl/blob/curl-7_84_0/CMakeLists.txt#L1539
set(SINSP_PKG_CONFIG_LIBS)
set(SINSP_PKG_CONFIG_LIBDIRS "")
foreach(sinsp_lib ${SINSP_PKGCONFIG_LIBRARIES})
	if(${sinsp_lib} MATCHES "^-")
		# We have a flag. Pass it through unchanged.
		list(APPEND SINSP_PKG_CONFIG_LIBS ${sinsp_lib})
	elseif(${sinsp_lib} MATCHES "/")
		# We have a path. Convert it to -L<dir> + -l<lib>.
		get_filename_component(sinsp_lib_dir ${sinsp_lib} DIRECTORY)
		list(APPEND SINSP_PKG_CONFIG_LIBDIRS -L${sinsp_lib_dir})
		get_filename_component(sinsp_lib_base ${sinsp_lib} NAME_WE)
		string(REGEX REPLACE "^lib" "" sinsp_lib_base ${sinsp_lib_base})
		list(APPEND SINSP_PKG_CONFIG_LIBS -l${sinsp_lib_base})
	elseif(${sinsp_lib} STREQUAL "scap")
		# We require libscap.pc, so skip it.
	else()
		# Assume we have a plain library name. Prefix it with "-l".
		list(APPEND SINSP_PKG_CONFIG_LIBS -l${sinsp_lib})
	endif()
endforeach()

# Build our pkg-config "Cflags:" flags.
set(SINSP_PKG_CONFIG_INCLUDES "")
foreach(sinsp_include_directory ${LIBSINSP_INCLUDE_DIRS})
	list(APPEND SINSP_PKG_CONFIG_INCLUDES -I${sinsp_include_directory})
endforeach()

string(REPLACE ";" " " SINSP_PKG_CONFIG_LIBS "${SINSP_PKG_CONFIG_LIBS}")
list(REMOVE_DUPLICATES SINSP_PKG_CONFIG_LIBDIRS)
string(REPLACE ";" " " SINSP_PKG_CONFIG_LIBDIRS "${SINSP_PKG_CONFIG_LIBDIRS}")
list(REMOVE_DUPLICATES SINSP_PKG_CONFIG_INCLUDES)
string(REPLACE ";" " " SINSP_PKG_CONFIG_INCLUDES "${SINSP_PKG_CONFIG_INCLUDES}")
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libsinsp.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libsinsp.pc @ONLY)

=== debian/changelog ===
falcosecurity-libs (0.15.1-2ubuntu1) noble; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Ignore test failures on armhf/s390x (fixes armhf/s390x ftbfs)
    - disable LTO, fix FTBFS (fixes amd64 ftbfs)
    - Use liblua5.3-dev instead of liblua5.1-dev to fix ftbfs
      on riscv64 and ppc64el.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 16 Apr 2024 08:34:08 +0200

falcosecurity-libs (0.15.1-2) unstable; urgency=medium

  * Re-imported the 0.14.1-5.1 NMU (Closes: #1068827)
    This was forgotten by mistake

 -- Dima Kogan <dkogan@debian.org>  Thu, 11 Apr 2024 23:21:24 -0700

falcosecurity-libs (0.15.1-1ubuntu3) noble; urgency=medium

  * Also disable test failures on s390x

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 11 Apr 2024 22:21:13 +0200

falcosecurity-libs (0.15.1-1ubuntu2) noble; urgency=medium

  [ Bo YU ]
  * Use liblua5.3-dev instead of liblua5.1-dev to fix ftbfs 
    on riscv64 and ppc64el. (Closes: #1068731)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 11 Apr 2024 19:49:30 +0200

falcosecurity-libs (0.15.1-1ubuntu1) noble; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Ignore test failures on armhf (fixes armhf ftbfs)
    - disable LTO, fix FTBFS (fixes amd64 ftbfs)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 11 Apr 2024 11:01:03 +0200

falcosecurity-libs (0.15.1-1) unstable; urgency=medium

  * New upstream release

 -- Dima Kogan <dkogan@debian.org>  Sat, 06 Apr 2024 11:54:51 -0700

falcosecurity-libs (0.14.1-5.1ubuntu5) noble; urgency=medium

  * Rebuild against new old abseil.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 11 Apr 2024 09:56:03 +0200

falcosecurity-libs (0.14.1-5.1ubuntu4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:13:36 +0000

falcosecurity-libs (0.14.1-5.1ubuntu3) noble; urgency=medium

  * debian/patches/linux-6.8-s-strlcpy-strscpy-g.patch: 
    - Linux 6.8: fix FTBFS (LP: #2058670)

 -- Paolo Pisati <paolo.pisati@canonical.com>  Thu, 21 Mar 2024 15:53:57 +0000

falcosecurity-libs (0.14.1-5.1ubuntu2) noble; urgency=medium

  * No-change rebuild against libcurl4t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 06:14:45 +0000

falcosecurity-libs (0.14.1-5.1ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Ignore test failures on armhf (fixes armhf ftbfs)
    - disable LTO, fix FTBFS (fixes amd64 ftbfs)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 29 Feb 2024 17:12:20 +0100

falcosecurity-libs (0.14.1-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add versioned dependency on dpkg-dev to guard against accidental backports
    with wrong ABI. (Closes: #1062545)

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 29 Feb 2024 16:16:34 +1300

falcosecurity-libs (0.14.1-5ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Ignore test failures on armhf (fixes armhf ftbfs)
    - disable LTO, fix FTBFS (fixes amd64 ftbfs)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 03 Feb 2024 13:27:09 +0100

falcosecurity-libs (0.14.1-5) unstable; urgency=medium

  * Rename libraries for 64-bit time_t transition (Closes: #1062545)
    Thanks to Michael Hudson-Doyle <mwhudson@debian.org>

 -- Dima Kogan <dkogan@debian.org>  Fri, 02 Feb 2024 22:44:12 -0800

falcosecurity-libs (0.14.1-4) unstable; urgency=medium

  * Make chisels work with the separately-shipped sysdig tool

 -- Dima Kogan <dkogan@debian.org>  Thu, 01 Feb 2024 22:27:26 -0800

falcosecurity-libs (0.14.1-3ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Ignore test failures on armhf (fixes armhf ftbfs)
    - disable LTO, fix FTBFS (fixes amd64 ftbfs)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 29 Jan 2024 09:10:14 +0100

falcosecurity-libs (0.14.1-2ubuntu3) noble; urgency=medium

  * Use lua instead of luajit

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 27 Jan 2024 09:57:02 +0100

falcosecurity-libs (0.14.1-2ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Ignore test failures on armhf (fixes armhf ftbfs)
    - make sure we don't link libluajit on ppc64el and riscv64 (fixes
      ppc64el/riscv64 ftbfs)
    - disable LTO, fix FTBFS (fixes amd64 ftbfs)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 27 Jan 2024 07:27:06 +0100

falcosecurity-libs (0.14.1-1ubuntu2) noble; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Use lua everywhere (fixes arm64/s390x ftbfs)
    - Ignore test failures on armhf (fixes armhf ftbfs)
    - make sure we don't link libluajit on ppc64el and riscv64 (fixes
      ppc64el/riscv64 ftbfs)
    - disable LTO, fix FTBFS (fixes amd64 ftbfs)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 26 Jan 2024 09:57:28 +0100

falcosecurity-libs (0.11.3+repack-6ubuntu2) noble; urgency=medium

  * debian/patches/fix-driver-fixed-build-against-6.6-rc-kernel.patch:
    - Linux 6.6 FTBFS fix (LP: #2041510)

 -- Paolo Pisati <paolo.pisati@canonical.com>  Fri, 27 Oct 2023 07:41:24 +0000

=== debian/control ===
Source: falcosecurity-libs
Section: libdevel
Priority: optional
Maintainer: Dima Kogan <dkogan@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5),
               cmake,
               debhelper-compat (= 13),
               libvalijson-dev (>= 0.6),
               libb64-dev,
               libc-ares-dev,
               libcurl4-openssl-dev,
               libgrpc++-dev,
               libgrpc-dev,
               libgtest-dev,
               libjq-dev,
               libjsoncpp-dev,
               libprotobuf-dev,
               libssl-dev,
               libtbb-dev,
               zlib1g-dev,
               libjsoncpp-dev,
               protobuf-compiler,
               protobuf-compiler-grpc,
               libprotobuf-dev,
               libluajit-5.1-dev [amd64 arm64 armel armhf i386 mips64el s390x] | liblua5.3-dev,
               libelf-dev,
               libre2-dev,
               libcap-dev,
               uthash-dev
Build-Depends-Indep: dh-sequence-dkms
Testsuite: autopkgtest-pkg-dkms
Standards-Version: 4.6.0
Homepage: https://github.com/falcosecurity/libs
Vcs-Git: https://salsa.debian.org/debian/falcosecurity-libs.git
Vcs-Browser: https://salsa.debian.org/debian/falcosecurity-libs

Package: libfalcosecurity0t64
Provides: ${t64:Provides}
Replaces: libfalcosecurity0
Breaks: libfalcosecurity0 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Core libraries for Falco and Sysdig
 Sysdig instruments your physical and virtual machines at the OS level
 by installing into the Linux kernel and capturing system calls and
 other OS events. Then, using sysdig's command line interface, you can
 filter and decode these events in order to extract useful information
 and statistics.
 .
 This package contains the run-time libraries to read the events from the
 driver.

Package: libfalcosecurity0-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libfalcosecurity0t64 (= ${binary:Version})
Description: Core libraries for Falco and Sysdig
 Sysdig instruments your physical and virtual machines at the OS level
 by installing into the Linux kernel and capturing system calls and
 other OS events. Then, using sysdig's command line interface, you can
 filter and decode these events in order to extract useful information
 and statistics.
 .
 This package contains the build-time libraries to read the events from the
 driver.

Package: falcosecurity-scap-dkms
Section: kernel
Architecture: all
Depends: ${misc:Depends}
Recommends: sysdig
Description: Kernel driver for Falco and Sysdig
 Sysdig instruments your physical and virtual machines at the OS level
 by installing into the Linux kernel and capturing system calls and
 other OS events. Then, using sysdig's command line interface, you can
 filter and decode these events in order to extract useful information
 and statistics.
 .
 This package contains the sources for the kernel driver used by Falco and
 Sysdig to collect data

=== debian/watch ===
version=4
https://github.com/falcosecurity/libs/tags .*/(0\.\d\S+)\.tar\.gz
